<?php
if(!session_id()) session_start();
// List of modules
$moduleList=array_diff(scandir("modules"), array('..', '.'));
$modules=readComponents($moduleList); // Global

$_SESSION['modules']=$modules;

echo ("<html>");
writeHeaders($moduleList);

/* Setting layout */
echo ("<body>");
writeTop();           //  Drawing layout header
writeMenu($modules);  //  Drawing menus

writeModulesContainers($modules);

// Writing snacknbar
echo ("<div id='snack' data-toggle='snackbar' data-html-allowed='true' data-content=''></div>	");
echo ("</body>");
echo ("</html>");

importCommonLibraries();
importCommonScripts();

/*  Main Functions  */

function writeModulesContainers($modules){
  echo ('<div id="moduleContainer">'); /* Main Space for modules content */

  /* Display Server Info */
  echo "<div class='moduleWindow' id='info' style='display: block'>";
    require("info.php");
  echo "</div>";

  /*foreach($modules as $key=>$value){
    $module=$key;
    // Drawing main module div
    echo "<div class='moduleWindow' id='$module' content='".$value['main']."' iscomponent='false'></div>";

    // Drawing divs for module components
    if (count($value["components"]>0)){
      foreach($value["components"] as $component){
        echo "<div class='moduleWindow' module='".$module."' id='".$component['id'].
             "' content='".$component['main']."' iscomponent='true'></div>";
      }
    } // end if
  } // End for each*/


  echo ("</div>"); /* End div for main space for modules */
}



  /*foreach ($modules as $module){
    echo "<div class='moduleWindow' id='$module' content='modules/$module/src/main.html' iscomponent='false'>";
      //require("modules/$module/src/main.html");
      // LOADMODULE
    echo "</div>";
    // Loading  components in module
    }

    foreach ($components as $component){
      //echo($component[1]);
      echo "<div class='moduleWindow' id='$component[0]' content=$component[1] iscomponent='true'>";
        //require($component['1']);

      echo "</div>";
    }*/


function importCommonScripts(){
  /* Common Scripts */
	echo('<script type="text/javascript" src="js/main.js"></script>');
  echo('<script type="text/javascript" src="js/sidebar_menu.js"></script>');
  echo('<script type="text/javascript" src="lib/node_modules/jed/jed.js"></script>');
  echo('<script type="text/javascript" src="lib/i18n.js"></script>');
};

function importCommonLibraries(){
  echo ('<!-- Common Libraries -->');
  echo ('<script type="text/javascript" src="lib/jquery-2.1.0.min.js"></script>');
  echo ('<script type="text/javascript" src="lib/jquery.xmlrpc.js"></script>');

  echo ('<script type="text/javascript" src="lib/bootstrap/js/bootstrap.min.js"></script>');
  echo ('<script type="text/javascript" src="lib/bootstrap-design/js/ripples.min.js"></script>');
  echo ('<script type="text/javascript" src="lib/bootstrap-design/js/material.min.js"></script>');
  echo ('<script type="text/javascript" src="lib/snackbar/snackbar.min.js"></script>');
  echo ('<script type="text/javascript" src="lib/bootbox.min.js"></script>');
  echo ('<script type="text/javascript" src="lib/waitwin.js"></script>');
  echo ('<script type="text/javascript" src="lib/utils.js"></script>');
};

function readComponents($modules){
  $modulefilelist=array();

  foreach($modules as $moduleName){
    $moduleManifestString = file_get_contents("modules/".$moduleName."/module.json");
    $module=(json_decode($moduleManifestString, TRUE));
    $modulefilelist[$moduleName]=$module;
  }
  return $modulefilelist;
}

function write($content){
  echo "<pre>";
  print_r($content);
  echo "/<pre>";
}

function writeTop(){

  echo('<div id="topBar" class="default-primary-color">');
    echo ("<span i18n id='bt_logout'>logout</span>");
  echo('</div>');
}

function writeHeaders($mod){
  ?>
  <head>
    <!-- Common Styles -->
     <meta charset="UTF-8">
    <link rel="stylesheet" href="css/sidebar-menu.css">
    <link rel="stylesheet" href="lib/bootstrap/css/bootstrap.min.css">
    <link rel="stylesheet" href="lib/bootstrap-design/css/ripples.min.css">
    <link rel="stylesheet" href="lib/bootstrap-design/css/material.min.css">
    <link rel="stylesheet" href="lib/snackbar/snackbar.css">
    <link rel="stylesheet" href="css/main.css">
    <link rel="stylesheet" href="css/waitwin.css">
    <!--link rel="stylesheet" href="lib/bootstrap-design/css/material-fullpalette.min.css"-->


  </head>
<?php }

function WriteMenu($modules){
  ?>
    <div id="leftMenu">
    <div id="wrapper" class="toggled-2">
        <!-- Sidebar -->
        <div id="sidebar-wrapper" class="default-primary-color">
		  <div id="sidebar_header"></div>
            <ul class="sidebar-nav nav-pills nav-stacked" id="menu">
              <?php
                  foreach($modules as $key=>$value){
                    $module=$key;
                      //error_log($value["icon"]);
                      if (array_key_exists("icon", $value) && file_exists("modules/$module/src/icons/".$value["icon"]))  $icon="modules/$module/src/icons/".$value["icon"];
                      else $icon="icons/default.png";

                      echo ("<li><a class='menuitem' target='$module'>".
                      "<span class='fa-stack fa-lg pull-left'><div class='moduleIcon' style='background-image:url($icon)'></div>".
                      "</span>".$value["name"]."</a>");


                        if (count($value["components"]>0)){
                          echo ('<ul class="nav-pills nav-stacked" style="list-style-type:none; margin-left: -40px;">');
                          foreach($value["components"] as $component){

                            if (array_key_exists("icon", $component) && file_exists("modules/$module/src/icons/".$component["icon"]))  $icon="modules/$module/src/icons/".$component["icon"];
                            else $icon="icons/default.png";


                            echo('<li><a class="menuitem" module="'.$module.
                            '" target="'.$component['id'].'"><span class="fa-stack fa-lg pull-left" style="margin-left:40px;">
                            <div class="moduleIcon" style="background-image:url('.$icon.')"></div></span>'.
                            '<span i18n class="translateable" domain="'.$module.'" menuEntry="'.$component["menuEntry"].'"></span>'.
                            '</a></li>');
                            //$component["menuEntry"].'</a></li>');

                            /*echo('<li><a class="menuitem" module="'.$module.
                            '" target="'.$component['id'].'"><span class="fa-stack fa-lg pull-left">
                            <div class="moduleIcon" style="background-image:url('.$icon.')"></div></span>'.
                            $component["menuEntry"].'</a></li>');*/
                          }
                          echo ('</ul>');
                        }
                        echo ("</li>");
                  }
              ?>
            </ul>
        <div id="sidebar_module_description_div" class="menuitem">
		  <span id="sidebar_module_description_image" class="fa-stack fa-lg pull-left"><div class="moduleIcon" style="background-image:url(modules/lliurex-guard/src/icons/guard_flat.png)"></div></span>
		  <!--span >Pajaritos tralari... esto es la descvripción del modulo...</span-->
		  <span id="sidebar_module_description_text">Pajaritos tralari... esto es la descvripción del modulo...</span>
		  </span>  
		</div>
		</div>
    </div>
  </div>


<?php
}
?>
